//+------------------------------------------------------------------+
//|                                           II_Dragon_OC_Lines.mq4 |
//|                            Copyright  2010, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| v 1.0 20/10/10
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Insanity Industries"
#property link      "http://www.insanityindustries.net"
#property indicator_chart_window

extern int force_tf=60;
extern int object_layer = 50;
extern int line_style = 0;
extern int line_width = 1;
extern bool show_history = true;
extern color color_high = LimeGreen;
extern color color_high_old = DarkGreen;
extern color color_low = Red;
extern color color_low_old = Maroon;


double point;

string TAG,pair;

datetime barstart;

double po,pc,o,c,h,l;

int tf;

int init(){
   if (object_layer>220) object_layer = 220;
   if(force_tf==0) tf = Period();
      else tf = force_tf;
   TAG = CharToStr(26+object_layer)+"II_Dragon_OC_Lines"+tf;
   pair = Symbol();
   point=Point;
   if(Digits==3||Digits==5) point*=10;
   barstart=0;
   Comment("");
   return(0);
}

int deinit(){
   ObDeleteObjectsByPrefix(TAG);
   return(0);
}

int start(){
   int i,j;
   color k;
   if(barstart<iTime(pair,tf,0)){
      barstart = iTime(pair,tf,0);
      int bars = iBars(pair,tf);
      ObDeleteObjectsByPrefix(TAG);
      for(i=bars-2;i>=1;i--){
// o-c>0 = red
         o=iOpen(pair,tf,i);
         c=iClose(pair,tf,i);
         po=iOpen(pair,tf,i+1);
         pc=iClose(pair,tf,i+1);
         if(o-c>0 && po-pc<0){ // red->green LOW/SUPPORT/DEMAND
            k = color_high;
            for(j=i-1;j>=1;j--){
               if(iHigh(pair,tf,j)>pc){
                  k = color_high_old;
                  if(show_history) DrawLine(iTime(pair,tf,i+1),iTime(pair,tf,j-1),i,pc,k);
                  break;
            }  }
            if(k==color_high) DrawLine(iTime(pair,tf,i+1),D'01.01.2019',i,pc,k);
         } else if(o-c<0 && po-pc>0){ //green->red HIGH/RESISTANCE/SUPPLY
            k = color_low;
            for(j=i-1;j>=1;j--){
               if(iLow(pair,tf,j)<pc){
                  k = color_low_old;
                  if(show_history) DrawLine(iTime(pair,tf,i+1),iTime(pair,tf,j-1),i,pc,k);
                  break;
            }  }
            if(k==color_low) DrawLine(iTime(pair,tf,i+1),D'01.01.2019',i,pc,k);
   }  }  }
   return(0);
}

void ObDeleteObjectsByPrefix(string Prefix){ // code by TRO
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()){
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix){ 
         i++; 
         continue;
      }
      ObjectDelete(ObjName);
}  }

void DrawLine(datetime t1, datetime t2,int i, double p, color c){
   string s = TAG+i;
   ObjectCreate(s,OBJ_TREND,0,0,0,0,0);
   ObjectSet(s,OBJPROP_COLOR,c);
   ObjectSet(s,OBJPROP_TIME1,t1);
   ObjectSet(s,OBJPROP_TIME2,t2);
   ObjectSet(s,OBJPROP_PRICE1,p);
   ObjectSet(s,OBJPROP_PRICE2,p);
   ObjectSet(s,OBJPROP_RAY,false);
   ObjectSet(s,OBJPROP_STYLE,line_style);
   ObjectSet(s,OBJPROP_WIDTH,line_width);
}

